org.keycloak.storage.user

## Interface UserQueryProvider

- All Known Subinterfaces:
    CacheUserProvider, UserProvider
  All Known Implementing Classes:
    JpaUserProvider, MongoUserProvider, UserCacheSession, UserFederationManager, UserStorageManager

      public interface UserQueryProvider

  Version:
    $Revision: 1 $
  Author:
    Bill Burke

- - ### Method Summary

    All Methods Instance Methods Abstract Methods
    Modifier and Type | Method and Description
    --- | ---
    `List<UserModel>` | `getGroupMembers(RealmModel realm, GroupModel group)`
    `List<UserModel>` | `getGroupMembers(RealmModel realm, GroupModel group, int firstResult, int maxResults)`
    `List<UserModel>` | `getUsers(RealmModel realm)`
    `List<UserModel>` | `getUsers(RealmModel realm, int firstResult, int maxResults)`
    `int` | `getUsersCount(RealmModel realm)`
    `List<UserModel>` | `searchForUser(Map<String,String> params, RealmModel realm)` Search for user by parameter.
    `List<UserModel>` | `searchForUser(Map<String,String> params, RealmModel realm, int firstResult, int maxResults)` Search for user by parameter.
    `List<UserModel>` | `searchForUser(String search, RealmModel realm)` Search for users with username, email or first + last name that is like search string.
    `List<UserModel>` | `searchForUser(String search, RealmModel realm, int firstResult, int maxResults)` Search for users with username, email or first + last name that is like search string.
    `List<UserModel>` | `searchForUserByUserAttribute(String attrName, String attrValue, RealmModel realm)`

- - ### Method Detail

    - #### getUsersCount

          int getUsersCount(RealmModel realm)

    - #### getUsers

          List<UserModel> getUsers(RealmModel realm)

    - #### getUsers

          List<UserModel> getUsers(RealmModel realm,
                                   int firstResult,
                                   int maxResults)

    - #### searchForUser

          List<UserModel> searchForUser(String search,
                                        RealmModel realm)

      Search for users with username, email or first + last name that is like search string. If possible, implementations should treat the parameter values as partial match patterns i.e. in RDMBS terms use LIKE. This method is used by the admin console search box
      Parameters:
        `search` -
        `realm` -
      Returns:

    - #### searchForUser

          List<UserModel> searchForUser(String search,
                                        RealmModel realm,
                                        int firstResult,
                                        int maxResults)

      Search for users with username, email or first + last name that is like search string. If possible, implementations should treat the parameter values as partial match patterns i.e. in RDMBS terms use LIKE. This method is used by the admin console search box
      Parameters:
        `search` -
        `realm` -
        `firstResult` -
        `maxResults` -
      Returns:

    - #### searchForUser

          List<UserModel> searchForUser(Map<String,String> params,
                                        RealmModel realm)

      Search for user by parameter. Valid parameters are: "first" - first name "last" - last name "email" - email "username" - username If possible, implementations should treat the parameter values as partial match patterns i.e. in RDMBS terms use LIKE. This method is used by the REST API when querying users.
      Parameters:
        `params` -
        `realm` -
      Returns:

    - #### searchForUser

          List<UserModel> searchForUser(Map<String,String> params,
                                        RealmModel realm,
                                        int firstResult,
                                        int maxResults)

      Search for user by parameter. Valid parameters are: "first" - first name "last" - last name "email" - email "username" - username If possible, implementations should treat the parameter values as patterns i.e. in RDMBS terms use LIKE. This method is used by the REST API when querying users.
      Parameters:
        `params` -
        `realm` -
        `firstResult` -
        `maxResults` -
      Returns:

    - #### getGroupMembers

          List<UserModel> getGroupMembers(RealmModel realm,
                                          GroupModel group,
                                          int firstResult,
                                          int maxResults)

    - #### getGroupMembers

          List<UserModel> getGroupMembers(RealmModel realm,
                                          GroupModel group)

    - #### searchForUserByUserAttribute

          List<UserModel> searchForUserByUserAttribute(String attrName,
                                                       String attrValue,
                                                       RealmModel realm)

Copyright © 2016 JBoss by Red Hat. All rights reserved.